/*
   Alfi-plotter image drawer.
   Optimized horizontal lines method.

   Written by ond <taxman@bimbo.fjfi.cvut.cz> at 17021998su.
 */

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <conio.h>
#include "alfi.h"

void
die (const char *msg)
{
  printf ("%s\n", msg);
  exit (-1);
}

/*
   void users()
   {
   char k;
   k=getch();
   switch(k)
   {
   case 'p':
   case 'P':k=0;
   printf("paused! (press 'p')\n");
   while((k!='P')&&(k!='p'))k=getch();
   break;
   case 27:alfi_pen_up();
   fclose(fin);
   exit(1);
   break;
   }
   }
 */

int
line_print (const char *fname)
{
  int fd, x, d;
  char *buff;

  d = 1;

  fd = open (fname, O_RDONLY);
  if (fd == -1)
    die ("read error");

  printf ("enter line width: ");
  scanf ("%d", &x);
  buff = (char *) malloc (x);
  if (!buff)
    die ("low memory");

  printf ("line width=%d\n", x);

  while (read (fd, buff, x) == x)
    {
      alfi_print_horizontal_line (buff, x, d);
      alfi_horizontal (ALFI_DOWN);
      d = -d;
    }

  alfi_pen (ALFI_PEN_UP);
  close (fd);

  return 0;
}

int
main (int argc, char *args[])
{
  printf ("\nAlfi image printer 1.0\n");
  alfi_reset ();
  line_print (args[1]);
  alfi_vertical (-alfi_x);

  return 0;
}
