/*
   Alfi-plotter control unit.

   Written by ond <taxman@linux.fjfi.cvut.cz> at 15021998su.
 */

#include <stdio.h>
#include <conio.h>
#include "alfi.h"

void
main ()
{
  char k, x, y, step;

  printf ("\nAlfi control 1.0" \
	  "  left, right     carriage move\n" \
	  "  up, down        paper move\n" \
	  "  p               pen down/up\n" \
	  "  s               set step\n" \
	  "  q               quit\n");

  alfi_reset ();
  step = 5;
  k = getch ();
  while (k != 'q')
    {
      switch (k)
	{
	case 0:
	  k = getch ();
	  x = 0;
	  y = 0;
	  switch (k)
	    {
	    case 72:		//up

	      y = ALFI_UP;
	      break;
	    case 80:		//down

	      y = ALFI_DOWN;
	      break;
	    case 77:		//right

	      x = ALFI_RIGHT;
	      break;
	    case 75:		//left

	      x = ALFI_LEFT;
	      break;
	    }
	  if (x)
	    alfi_vertical (x * step);
	  else if (y)
	    alfi_horizontal (y * step);
	  break;
	case 'p':
	  alfi_pen (!alfi_pen_status);
	  break;
	case 's':
	  printf ("step=");
	  scanf ("%d", &step);
	  if (!step)
	    step = 1;
	  break;
	}
      k = getch ();
    }
  alfi_reset ();
}
